"""
contains pwe specfic validators
"""

import formbar.form as formbar_form
import collections

Validator = collections.namedtuple("Validator", "function message triggers")

validator_fns = []
_ = lambda x: x

# Action modes
CREATE = 0
UPDATE = 1

# Key values used in forms
JA = 1
NEIN = 0
QUALIFIZIERT = 0
MINIJOB = 2
PFLEGE = 1
HDL = 3
TRIFFT_NICHT_ZU_KINDER = 5
TRIFFT_NICHT_ZU_PFLEGE = 4
WENIGER_ALS_EIN_JAHR = 1
KEINE_PAUSE = 5

# Placeholders, namespace reflecting keys will be set by _set_namespace()
ZIELGRUPPE = ""
PAUSE_WEGEN_KINDER = ""
PAUSE_WEGEN_PFLEGE = ""
FAMILIENPHASE = ""
ERWERBSTAETIG = ""
ERWERBSPAUSE = ""
IN_ALLGEMEINBILDENDER_SCHULE = ""
AUSZUBILDENDER = ""
IN_SCHULISCHER_AUSBILDUNG = ""
VOLLZEIT_STUDENT = ""
LANGZEITARBEITSLOS = ""
ADAEQUATE_BERUFSERFAHRUNG_PFLEGENDE = ""
ADAEQUATE_BERUFSERFAHRUNG_GUT_QUALIFIZIERTE = ""
SELBSTAENDIG = ""
GERINGFUEGIGE_SELBSTAENDIGKEIT = ""
MINIJOB_WEGEN_PFLEGE = ""

NOT_ELIGIBLE = _("The participant is not eligible, beacause: ")

KEINE_LANGZEITARBEITSLOSEN = _("Longterm unemployed selected (32.1) was selected")
KINDER_UND_PFLEGE_TRIFFT_NICHT_ZU = _("Neither children nor care does apply (8.1, 31.1, 31.2)")
KEINE_FAMILIENPHASE = _("No familyphase (8.1, 8.2) was selected")
KEINE_ERWERBSTAETIGEN = _("No employed people (16.1) was selected")
KEINE_ERWERBSPAUSE = _("No pause  was selected (8.1, 30)")
KURZE_ERWERBSPAUSE_OHNE_PFLEGE = _("Pause less than a year was selected without care (8.1, 30, 31.2)")
KEINE_NOCH_IN_BILDUNG = _("Is still in Education (8.1, 16.4, 16.5, 16.6, 16.7)")
KEINE_PFLEGE_OHNE_BERUFSERFAHRUNG = _("No adequate jobexperience with care (8.1, 18.2)")
KEIN_MINIJOB_WEGEN_PFLEGE = _("No minijob due to care (8.1, 16.2.1)")
KEINE_QUALIFIZIERTEN_OHNE_BERUFSERFAHRUNG = _("No adequate jobexperience as qualified (8.1, 18.1)")
KEINE_GERINGE_SELBSTAENDIGKEIT = _("No minijoblike selfemployment (8.1, 16.3.1)")
KEINE_PFLEGE_OHNE_FAMILIENPHASE_WEGEN_KINDER = _("Care and no children familyphase (8.1, 8.2)")
PFLEGE_KEINE_ERWERBSPAUSE_WEGEN_PFLEGE = _("No pause due to care but qualified as care (8.1, 31.2)")

def _set_namespace(action):
    """Overwrite the global name placeholder in case of a CREATE action."""

    global ZIELGRUPPE
    global PAUSE_WEGEN_KINDER
    global PAUSE_WEGEN_PFLEGE
    global FAMILIENPHASE
    global ERWERBSTAETIG
    global ERWERBSPAUSE
    global IN_ALLGEMEINBILDENDER_SCHULE
    global AUSZUBILDENDER
    global IN_SCHULISCHER_AUSBILDUNG
    global VOLLZEIT_STUDENT
    global LANGZEITARBEITSLOS
    global ADAEQUATE_BERUFSERFAHRUNG_PFLEGENDE
    global ADAEQUATE_BERUFSERFAHRUNG_GUT_QUALIFIZIERTE
    global SELBSTAENDIG
    global GERINGFUEGIGE_SELBSTAENDIGKEIT
    global MINIJOB_WEGEN_PFLEGE

    if action == CREATE:
        ZIELGRUPPE = "_pwe_targetgroup"
        PAUSE_WEGEN_KINDER = "_pwe_acquisition_pause_reason"
        PAUSE_WEGEN_PFLEGE = "_pwe_acquisition_pause_reason_care"
        FAMILIENPHASE = "_pwe_targetgroup_family_phase"
        ERWERBSTAETIG = "_lm_employment_category_employed"
        ERWERBSPAUSE = "_pwe_acquisition_pause"
        IN_ALLGEMEINBILDENDER_SCHULE = "_lm_employment_category_school"
        AUSZUBILDENDER = "_lm_employment_category_education_enterprise"
        IN_SCHULISCHER_AUSBILDUNG = "_lm_employment_category_education_school"
        VOLLZEIT_STUDENT = "_lm_employment_category_fulltime_student"
        LANGZEITARBEITSLOS = "_pwe_labour_interruption"
        ADAEQUATE_BERUFSERFAHRUNG_PFLEGENDE = "_edu_attainment_vocational_experience2"
        ADAEQUATE_BERUFSERFAHRUNG_GUT_QUALIFIZIERTE = "_edu_attainment_vocational_experience"
        SELBSTAENDIG = "_lm_employment_category_selfemployed"
        GERINGFUEGIGE_SELBSTAENDIGKEIT = "_lm_employment_category_selfemployed_reduced"
        MINIJOB_WEGEN_PFLEGE = "_lm_employment_category_underemployed_reduced"
    else:
        ZIELGRUPPE = "pweoi.pwe_targetgroup"
        PAUSE_WEGEN_KINDER = "pweoi.pwe_acquisition_pause_reason"
        PAUSE_WEGEN_PFLEGE = "pweoi.pwe_acquisition_pause_reason_care"
        FAMILIENPHASE = "pweoi.pwe_targetgroup_family_phase"
        ERWERBSTAETIG = "pweoi.lm_employment_category_employed"
        ERWERBSPAUSE = "pweoi.pwe_acquisition_pause"
        IN_ALLGEMEINBILDENDER_SCHULE = "pweoi.lm_employment_category_school"
        AUSZUBILDENDER = "pweoi.lm_employment_category_education_enterprise"
        IN_SCHULISCHER_AUSBILDUNG = "pweoi.lm_employment_category_education_school"
        VOLLZEIT_STUDENT = "pweoi.lm_employment_category_fulltime_student"
        LANGZEITARBEITSLOS = "pweoi.pwe_labour_interruption"
        ADAEQUATE_BERUFSERFAHRUNG_PFLEGENDE = "pweoi.edu_attainment_vocational_experience2"
        ADAEQUATE_BERUFSERFAHRUNG_GUT_QUALIFIZIERTE = "pweoi.edu_attainment_vocational_experience"
        SELBSTAENDIG = "pweoi.lm_employment_category_selfemployed"
        GERINGFUEGIGE_SELBSTAENDIGKEIT = "pweoi.lm_employment_category_selfemployed_reduced"
        MINIJOB_WEGEN_PFLEGE = "pweoi.lm_employment_category_underemployed_reduced"


def Validate(error_message="", triggers="warning"):
    def outer(fun):
        def generate_validation_function(fn):
            def eligibility_validator(field, data, request):
                try:
                    formdata = Entries(data)
                    fn(formdata)
                except AssertionError:
                    return False
                else:
                    return True
            return eligibility_validator
        f = generate_validation_function(fun)
        validator_fns.append(Validator(f, error_message, triggers))

        def inner(field, data, request):
            return f(field, data, request)
        return inner
    return outer

class Entries(object):

    def __init__(self, data):
        self.data = data

    def is_selected(self, option, value):
        return self.data.get(option) == value

    def check_option(self, option, check_function=None):
        if not check_function:
            check_function = lambda x: True
        return check_function(self.data.get(option))

def qualifiziert_oder_minijob_oder_hdl(form):
    return (form.is_selected(ZIELGRUPPE, QUALIFIZIERT) or
            form.is_selected(ZIELGRUPPE, MINIJOB) or
            form.is_selected(ZIELGRUPPE, HDL))

def qualifiziert_oder_pflege_oder_minijob(form):
    return (form.is_selected(ZIELGRUPPE, QUALIFIZIERT) or
            form.is_selected(ZIELGRUPPE, PFLEGE) or
            form.is_selected(ZIELGRUPPE, MINIJOB))

@Validate(error_message=KEINE_LANGZEITARBEITSLOSEN, triggers="error")
def long_term_unemployed(selected):
    if qualifiziert_oder_pflege_oder_minijob(selected):
        assert(not selected.is_selected(LANGZEITARBEITSLOS, JA))

@Validate(error_message=KINDER_UND_PFLEGE_TRIFFT_NICHT_ZU, triggers="error")
def check_targetgroup_children_care(form):
    if qualifiziert_oder_minijob_oder_hdl(form):
        pausenzeiten = (form.is_selected(PAUSE_WEGEN_KINDER, TRIFFT_NICHT_ZU_KINDER) and
                        form.is_selected(PAUSE_WEGEN_PFLEGE, TRIFFT_NICHT_ZU_PFLEGE))
        assert(not pausenzeiten)

@Validate(error_message=KEINE_FAMILIENPHASE, triggers="error")
def check_targetgroup_familyphase(form):
    if qualifiziert_oder_minijob_oder_hdl(form):
        assert(not form.is_selected(FAMILIENPHASE, NEIN))

@Validate(error_message=KEINE_ERWERBSTAETIGEN, triggers="error")
def check_targetgroup_working(form):
    if qualifiziert_oder_minijob_oder_hdl(form):
        assert(not form.is_selected(ERWERBSTAETIG, JA))

@Validate(error_message=KEINE_ERWERBSPAUSE, triggers="error")
def check_targetgroup_pause(form):
    if qualifiziert_oder_minijob_oder_hdl(form):
        assert(not form.is_selected(ERWERBSPAUSE, KEINE_PAUSE))

@Validate(error_message=KURZE_ERWERBSPAUSE_OHNE_PFLEGE, triggers="error")
def check_targetgroup_pause_without_care(form):
    if qualifiziert_oder_minijob_oder_hdl(form):
        pausen = (form.is_selected(ERWERBSPAUSE, WENIGER_ALS_EIN_JAHR) and
                  form.is_selected(PAUSE_WEGEN_PFLEGE, TRIFFT_NICHT_ZU_PFLEGE))
        assert(not pausen)

@Validate(error_message=KEINE_NOCH_IN_BILDUNG, triggers="error")
def check_targetgroup_education(form):
    if qualifiziert_oder_minijob_oder_hdl(form):
        assert(not form.is_selected(IN_ALLGEMEINBILDENDER_SCHULE, JA))
        assert(not form.is_selected(AUSZUBILDENDER, JA))
        assert(not form.is_selected(IN_SCHULISCHER_AUSBILDUNG, JA))
        assert(not form.is_selected(VOLLZEIT_STUDENT, JA))

@Validate(error_message=KEINE_PFLEGE_OHNE_BERUFSERFAHRUNG, triggers="error")
def no_finished_education(form):
    if form.is_selected(ZIELGRUPPE, PFLEGE):
        assert(not form.is_selected(ADAEQUATE_BERUFSERFAHRUNG_PFLEGENDE, NEIN))

@Validate(error_message=KEINE_PFLEGE_OHNE_FAMILIENPHASE_WEGEN_KINDER, triggers="error")
def no_finished_education_children(form):
    if form.is_selected(ZIELGRUPPE, PFLEGE):
        assert(not form.is_selected(FAMILIENPHASE, NEIN))

@Validate(error_message=PFLEGE_KEINE_ERWERBSPAUSE_WEGEN_PFLEGE, triggers="error")
def no_finished_education_care(form):
    if form.is_selected(ZIELGRUPPE, PFLEGE):
        assert(not form.is_selected(PAUSE_WEGEN_PFLEGE, TRIFFT_NICHT_ZU_PFLEGE))

@Validate(error_message=KEIN_MINIJOB_WEGEN_PFLEGE, triggers="error")
def no_minijob(form):
    if form.is_selected(ZIELGRUPPE, PFLEGE):
        assert(not form.is_selected(MINIJOB_WEGEN_PFLEGE, NEIN))

@Validate(error_message=KEINE_QUALIFIZIERTEN_OHNE_BERUFSERFAHRUNG, triggers="error")
def no_qualified(form):
    if form.is_selected(ZIELGRUPPE, QUALIFIZIERT):
        assert(not form.is_selected(ADAEQUATE_BERUFSERFAHRUNG_GUT_QUALIFIZIERTE, NEIN))

@Validate(error_message=KEINE_GERINGE_SELBSTAENDIGKEIT, triggers="error")
def check_targetgroup_level3(form):
    if qualifiziert_oder_minijob_oder_hdl(form):
        geringe_selbstaendigkeit = (form.is_selected(SELBSTAENDIG, JA) and
                                    form.is_selected(GERINGFUEGIGE_SELBSTAENDIGKEIT, NEIN))
        assert(not geringe_selbstaendigkeit)

def get_eligibility_validators(request):
    if request.matched_route and request.matched_route.name and \
       (request.matched_route.name == u'participations-create'
        or request.matched_route.name == u'participants-create'):
            _set_namespace(CREATE)
    else:
            _set_namespace(UPDATE)
    return [generate_validator(request, v.message, v.function, v.triggers) for v in validator_fns]

def generate_validator(request, message, fn, t):
    _ = request.translate
    msg = _(NOT_ELIGIBLE) + _(message)
    return formbar_form.Validator(None, msg, fn,
                          request, triggers=t)
