from pyramid.view import view_config
import efa.views.participant as efa_views
from efa.model.participant import Participant
from ringo.lib.helpers import get_action_routename
import pwe.lib.validators as pwe_validators

@view_config(route_name=get_action_routename(Participant, 'create'),
             renderer='/default/create.mako',
             permission='create',
             request_method="POST")
def create(request):
    request.session['participant_partial_oi'] = extract_parts(request)
    validators = pwe_validators.get_eligibility_validators(request)
    return efa_views._create(request, validators)


def get_param(request, param):
    result = request.POST.get(param)
    if result == "":
        return None
    return result

def extract_parts(request):
    return {"pwe_targetgroup": get_param(request, "_pwe_targetgroup"),
            "pwe_acquisition_pause_reason": get_param(request, "_pwe_acquisition_pause_reason"),
            "pwe_acquisition_pause_reason_care": get_param(request, "_pwe_acquisition_pause_reason_care"),
            "pwe_targetgroup_family_phase": get_param(request, "_pwe_targetgroup_family_phase"),
            "lm_employment_category_employed": get_param(request, "_lm_employment_category_employed"),
            "pwe_acquisition_pause": get_param(request, "_pwe_acquisition_pause"),
            "lm_employment_category_school": get_param(request, "_lm_employment_category_school"),
            "lm_employment_category_education_enterprise": get_param(request,
                "_lm_employment_category_education_enterprise"),
            "lm_employment_category_education_school": get_param(request,
                "_lm_employment_category_education_school"),
            "lm_employment_category_fulltime_student": get_param(request,
                "_lm_employment_category_fulltime_student"),
            "pwe_labour_interruption": get_param(request, "_pwe_labour_interruption"),
            "edu_attainment_vocational": get_param(request, "_edu_attainment_vocational"),
            "edu_attainment_vocational_experience2": get_param(request, "_edu_attainment_vocational_experience2"),
            "edu_attainment_vocational_experience": get_param(request, "_edu_attainment_vocational_experience"),
            "lm_employment_category_selfemployed": get_param(request, "_lm_employment_category_selfemployed"),
            "lm_employment_category_selfemployed_reduced": get_param(request,
                "_lm_employment_category_selfemployed_reduced"),
            "lm_employment_category_underemployed": get_param(request,
                "_lm_employment_category_underemployed"),
            "lm_employment_category_underemployed_reduced": get_param(request,
                "_lm_employment_category_underemployed_reduced")}
